#ifndef COPERATIONFACOTRY_H
#define COPERATIONFACOTRY_H

#include "libboxmanage_global.h"

class QWidget;
namespace Box {

class COperation;
class LIBBOXMANAGE_EXPORT COperationFactory
{
public:
    COperationFactory();
    virtual ~COperationFactory();

public:
    typedef enum {
        ApplyCryptBoxOprInPeony = 0,    // 实现为空，作用未知， 未使用
        ReleaseCryptBoxOprInPeony = 1,  // 解锁挂载保护箱  通用
        CreateBoxOprInPeony = 2,        // 创建保护箱  通用
        DeleteBoxOprInPeony = 3,        // 删除保护箱 通用
        ReleaseLockBoxInOprPeony = 4,   // 卸载、校验保护箱密码  未使用
        RenameBoxOprInPeony = 5,        // 重命名保护箱 未使用
        SettingBoxOprInPeony = 6,       // 修改保护箱密码  通用
        LockBoxOprInPeony = 7,          // 锁定保护箱 通用
        RenameBoxOprInManager = 8,      // 重命名保护箱， 通用
        AuthCred = 9,                   // 口令认证  通用
        ExportKeyBoxOprInPeony = 10,    // 导出密钥
        CryptoModelSwitch = 11,         // 加密模式切换
        MaxOpr,
    } EOperation;

public:
    COperation *construct_operation(EOperation eOpr, QWidget *parent = nullptr);
};

}

#endif // COPERATIONFACOTRY_H
